diff -Naur qcacld-2.0-org/CORE/CLD_TXRX/HTT/htt_t2h.c qcacld-2.0-new/CORE/CLD_TXRX/HTT/htt_t2h.c
--- qcacld-2.0-org/CORE/CLD_TXRX/HTT/htt_t2h.c	2021-06-08 13:35:52.877228783 +0800
+++ qcacld-2.0-new/CORE/CLD_TXRX/HTT/htt_t2h.c	2021-06-08 13:36:15.604585634 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011-2014 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011-2014, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -206,11 +206,44 @@
             tid = HTT_RX_FRAG_IND_EXT_TID_GET(*msg_word);
             HTT_RX_FRAG_SET_LAST_MSDU(pdev, htt_t2h_msg);
 
+            /* If packet len is invalid, will discard this frame. */
+            if (pdev->cfg.is_high_latency) {
+                u_int32_t rx_pkt_len = 0;
+
+                rx_pkt_len = adf_nbuf_len(htt_t2h_msg);
+
+                if (rx_pkt_len < (HTT_RX_FRAG_IND_BYTES +
+                    sizeof(struct hl_htt_rx_ind_base)+
+                    sizeof(struct ieee80211_frame))) {
+
+                    adf_os_print("%s: invalid packet len, %u\n",
+                                __FUNCTION__,
+                                rx_pkt_len);
+                    /*
+                     * This buf will be freed before
+                     * exiting this function.
+                     */
+                    break;
+                }
+            }
+
             ol_rx_frag_indication_handler(
                 pdev->txrx_pdev,
                 htt_t2h_msg,
                 peer_id,
                 tid);
+
+            if (pdev->cfg.is_high_latency) {
+               /*
+                * For high latency solution, HTT_T2H_MSG_TYPE_RX_FRAG_IND
+                * message and RX packet share the same buffer. All buffer will
+                * be freed by ol_rx_frag_indication_handler or upper layer to
+                * avoid double free issue.
+                *
+                */
+                return;
+            }
+
             break;
         }
     case HTT_T2H_MSG_TYPE_RX_ADDBA:
diff -Naur qcacld-2.0-org/CORE/CLD_TXRX/TXRX/ol_cfg.c qcacld-2.0-new/CORE/CLD_TXRX/TXRX/ol_cfg.c
--- qcacld-2.0-org/CORE/CLD_TXRX/TXRX/ol_cfg.c	2021-06-08 13:35:52.877228783 +0800
+++ qcacld-2.0-new/CORE/CLD_TXRX/TXRX/ol_cfg.c	2021-06-08 13:36:15.604585634 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011-2014 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011-2014, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -66,6 +66,7 @@
 #if CFG_TGT_DEFAULT_RX_SKIP_DEFRAG_TIMEOUT_DUP_DETECTION_CHECK
 	cfg_ctx->defrag_timeout_check = 1;
 #endif
+	cfg_ctx->dup_check = 0;
 	cfg_ctx->max_peer_id = 511;
 	cfg_ctx->max_vdev = CFG_TGT_NUM_VDEV;
 	cfg_ctx->pn_rx_fwd_check = 1;
@@ -206,12 +207,19 @@
 	return cfg->tx_download_size;
 }
 
-int ol_cfg_rx_host_defrag_timeout_duplicate_check(ol_pdev_handle pdev)
+int ol_cfg_rx_host_defrag_timeout_check(ol_pdev_handle pdev)
 {
 	struct txrx_pdev_cfg_t *cfg = (struct txrx_pdev_cfg_t *)pdev;
 	return cfg->defrag_timeout_check;
 }
 
+int ol_cfg_rx_host_duplicate_check(ol_pdev_handle pdev)
+{	
+	struct txrx_pdev_cfg_t *cfg = (struct txrx_pdev_cfg_t *)pdev;
+	return cfg->dup_check;
+}
+
+
 int ol_cfg_throttle_period_ms(ol_pdev_handle pdev)
 {
 	struct txrx_pdev_cfg_t *cfg = (struct txrx_pdev_cfg_t *)pdev;
diff -Naur qcacld-2.0-org/CORE/CLD_TXRX/TXRX/ol_rx_defrag.c qcacld-2.0-new/CORE/CLD_TXRX/TXRX/ol_rx_defrag.c
--- qcacld-2.0-org/CORE/CLD_TXRX/TXRX/ol_rx_defrag.c	2021-06-08 13:35:52.881230782 +0800
+++ qcacld-2.0-new/CORE/CLD_TXRX/TXRX/ol_rx_defrag.c	2021-06-08 13:36:15.608587634 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011-2014 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011-2014, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -278,6 +278,8 @@
     struct ol_rx_reorder_array_elem_t *rx_reorder_array_elem;
     u_int16_t frxseq, rxseq, seq;
     htt_pdev_handle htt_pdev = pdev->htt_pdev;
+	void *rx_desc;  
+	int index;			   /* unicast vs. multicast */ 
 
     seq = seq_num & peer->tids_rx_reorder[tid].win_sz_mask;
     adf_os_assert(seq == 0);
@@ -290,13 +292,49 @@
         IEEE80211_SEQ_FRAG_MASK;
     more_frag = mac_hdr->i_fc[1] & IEEE80211_FC1_MORE_FRAG;
 
+	/*  
+	 * CR 2868034  
+	 * A broadcast or multicast frame should never be fragmented  
+	 * driver should drop all fragmented broadcast / multicast frames.  
+	 */  
+	rx_desc = htt_rx_msdu_desc_retrieve(htt_pdev, frag); 
+	if (htt_rx_msdu_is_wlan_mcast(htt_pdev, rx_desc)) {  
+	   /* Discard Mcast/Bcast single frag frames */  
+	   ol_rx_frames_free(htt_pdev, frag);  
+
+	   VOS_TRACE(VOS_MODULE_ID_TXRX, VOS_TRACE_LEVEL_ERROR,  
+	       "%s: QSV2020004 discard MCAST/BCAST frag frame\n\n",  
+	       __FUNCTION__);  
+	   return;  
+	}  
+     
+	index = htt_rx_msdu_is_wlan_mcast(htt_pdev, rx_desc) ?  
+	           txrx_sec_mcast : txrx_sec_ucast;  
+
+	if (peer->security[index].sec_type != htt_sec_type_none &&  
+	   !htt_rx_mpdu_is_encrypted(htt_pdev, rx_desc)) {  
+	   ol_rx_frames_free(htt_pdev, frag);  
+
+	   VOS_TRACE(VOS_MODULE_ID_TXRX, VOS_TRACE_LEVEL_ERROR,  
+	       "%s: QSV2020004, Unencrypted fragment received in security mode %d\n",  
+	       __FUNCTION__,  
+	       peer->security[index].sec_type); 
+
+	   return;  
+	} 
+
+
     if ((!more_frag) && (!fragno) && (!rx_reorder_array_elem->head)) {
-        rx_reorder_array_elem->head = frag;
-        rx_reorder_array_elem->tail = frag;
+        ol_rx_fraglist_insert(htt_pdev, peer,
+        &rx_reorder_array_elem->head,
+        &rx_reorder_array_elem->tail, frag, &all_frag_present);
         adf_nbuf_set_next(frag, NULL);
         ol_rx_defrag(pdev, peer, tid, rx_reorder_array_elem->head);
         rx_reorder_array_elem->head = NULL;
         rx_reorder_array_elem->tail = NULL;
+		VOS_TRACE(VOS_MODULE_ID_TXRX, VOS_TRACE_LEVEL_ERROR,
+            "%s: QSV2020008 not expected behavior, but also handled\n",
+            __FUNCTION__);
         return;
     }
     if (rx_reorder_array_elem->head) {
@@ -317,7 +355,8 @@
         }
     }
 
-    ol_rx_fraglist_insert(htt_pdev, &rx_reorder_array_elem->head,
+    ol_rx_fraglist_insert(htt_pdev, peer,
+    	&rx_reorder_array_elem->head,
         &rx_reorder_array_elem->tail, frag, &all_frag_present);
 
     if (pdev->rx.flags.defrag_timeout_check) {
@@ -344,6 +383,7 @@
 void
 ol_rx_fraglist_insert(
     htt_pdev_handle htt_pdev,
+    struct ol_txrx_peer_t *peer,
     adf_nbuf_t *head_addr,
     adf_nbuf_t *tail_addr,
     adf_nbuf_t frag,
@@ -353,11 +393,13 @@
     struct ieee80211_frame *mac_hdr, *cmac_hdr, *next_hdr, *lmac_hdr;
     u_int8_t fragno, cur_fragno, lfragno, next_fragno;
     u_int8_t last_morefrag = 1, count = 0;
+	int pn_len = 0;
+    void *rx_desc;
+    int index;              /* unicast vs. multicast */
+    union htt_rx_pn_t curr_pn, next_pn;
     adf_nbuf_t frag_clone;
 
     adf_os_assert(frag);
-    frag_clone = OL_RX_FRAG_CLONE(frag);
-    frag = frag_clone ? frag_clone : frag;
 
     mac_hdr = (struct ieee80211_frame *) OL_RX_FRAG_GET_MAC_HDR(htt_pdev, frag);
     fragno = adf_os_le16_to_cpu(*(u_int16_t *) mac_hdr->i_seq) &
@@ -391,6 +433,10 @@
         if (fragno == cur_fragno) {
             htt_rx_desc_frame_free(htt_pdev, frag);
             *all_frag_present = 0;
+			VOS_TRACE(VOS_MODULE_ID_TXRX, VOS_TRACE_LEVEL_ERROR,
+                   "\n%s:Duplicated frag No, fragno = %u, discard it\n",
+                   __FUNCTION__,
+                   fragno);
             return;
         } else {
             adf_nbuf_set_next(prev, frag);
@@ -402,15 +448,56 @@
                                                                 *tail_addr);
     last_morefrag = lmac_hdr->i_fc[1] & IEEE80211_FC1_MORE_FRAG;
     if (!last_morefrag) {
+		rx_desc = htt_rx_msdu_desc_retrieve(htt_pdev, *head_addr);
+        index = htt_rx_msdu_is_wlan_mcast(htt_pdev, rx_desc) ?
+                txrx_sec_mcast : txrx_sec_ucast;
+        pn_len = htt_pdev->txrx_pdev->rx_pn[peer->security[index].sec_type].len;
+        if (pn_len) {
+            htt_rx_mpdu_desc_pn(htt_pdev, rx_desc, &curr_pn, pn_len);
+        }
         do {
             next_hdr = (struct ieee80211_frame *) OL_RX_FRAG_GET_MAC_HDR(
                                                                 htt_pdev, next);
             next_fragno = adf_os_le16_to_cpu(*(u_int16_t *) next_hdr->i_seq) &
                 IEEE80211_SEQ_FRAG_MASK;
+			/*
+			* CR 2868016
+			* Perform strict PN check if non-consecutive
+			* discard all frags
+			*/	
+			if (pn_len) {	
+			/* retrieve PN from rx descriptor */	
+				rx_desc = htt_rx_msdu_desc_retrieve(htt_pdev, next);	
+				htt_rx_mpdu_desc_pn(htt_pdev, rx_desc, &next_pn, pn_len);	
+			}
             count++;
+			/*
+			* Fragment number consecutive is gauranteed
+			* by count++, all_frage_present only set to
+			* 1 when checking complete, otherwise, frags
+			* will be discard due to timeout
+			*/
             if (next_fragno != count) {
                 break;
             }
+			if (pn_len) {
+				if(!ol_rx_pn_strict_chk(&next_pn,
+				&curr_pn,
+				index == txrx_sec_ucast,
+				pn_len,
+				peer->vdev->opmode)) {
+					VOS_TRACE(VOS_MODULE_ID_TXRX, VOS_TRACE_LEVEL_ERROR,
+								"\n%s:QSV2020003 expected discard non-strict PN behavior, curr_pn=%llu, next_pn=%llu\n",
+								__FUNCTION__,
+								curr_pn.pn48,
+								next_pn.pn48
+								);
+		 		break;
+				}
+				vos_mem_copy((uint8_t *) &curr_pn,
+					(uint8_t *) &next_pn,
+					sizeof(union htt_rx_pn_t));
+			}
             next = adf_nbuf_next(next);
         } while (next);
 
@@ -448,14 +535,17 @@
     struct ol_txrx_pdev_t *pdev = peer->vdev->pdev;
     struct ol_rx_reorder_t *rx_reorder = &peer->tids_rx_reorder[tid];
 
-    if (rx_reorder->defrag_waitlist_elem.tqe_next != NULL ||
-        rx_reorder->defrag_waitlist_elem.tqe_prev != NULL) {
+    if (rx_reorder->defrag_waitlist_elem.tqe_prev != NULL) {
 
         TAILQ_REMOVE(&pdev->rx.defrag.waitlist, rx_reorder,
                 defrag_waitlist_elem);
 
         rx_reorder->defrag_waitlist_elem.tqe_next = NULL;
         rx_reorder->defrag_waitlist_elem.tqe_prev = NULL;
+    } else if (rx_reorder->defrag_waitlist_elem.tqe_next != NULL) {
+        TXRX_PRINT(TXRX_PRINT_LEVEL_FATAL_ERR, "waitlist->tqe_prv = NULL\n");
+        VOS_ASSERT(0);
+        rx_reorder->defrag_waitlist_elem.tqe_next = NULL;
     }
 }
 
diff -Naur qcacld-2.0-org/CORE/CLD_TXRX/TXRX/ol_rx_defrag.h qcacld-2.0-new/CORE/CLD_TXRX/TXRX/ol_rx_defrag.h
--- qcacld-2.0-org/CORE/CLD_TXRX/TXRX/ol_rx_defrag.h	2021-06-08 13:35:52.881230782 +0800
+++ qcacld-2.0-new/CORE/CLD_TXRX/TXRX/ol_rx_defrag.h	2021-06-08 13:36:15.608587634 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011-2014 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011-2014, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -63,6 +63,7 @@
 void
 ol_rx_fraglist_insert(
     htt_pdev_handle htt_pdev,
+    struct ol_txrx_peer_t *peer,
     adf_nbuf_t *head_addr,
     adf_nbuf_t *tail_addr,
     adf_nbuf_t frag,
diff -Naur qcacld-2.0-org/CORE/CLD_TXRX/TXRX/ol_rx_fwd.c qcacld-2.0-new/CORE/CLD_TXRX/TXRX/ol_rx_fwd.c
--- qcacld-2.0-org/CORE/CLD_TXRX/TXRX/ol_rx_fwd.c	2021-06-08 13:35:52.881230782 +0800
+++ qcacld-2.0-new/CORE/CLD_TXRX/TXRX/ol_rx_fwd.c	2021-06-08 13:36:15.608587634 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011, 2014 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011, 2014, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -181,6 +181,7 @@
 
         if (!vdev->disable_intrabss_fwd &&
             htt_rx_msdu_forward(pdev->htt_pdev, rx_desc)) {
+            int do_not_fwd = 0;
             /*
              * Use the same vdev that received the frame to
              * transmit the frame.
@@ -213,15 +214,43 @@
              * Check whether it also needs to be sent to the OS shim,
              * in which case we need to make a copy (or clone?).
              */
-            if (htt_rx_msdu_discard(pdev->htt_pdev, rx_desc)) {
-                htt_rx_msdu_desc_free(pdev->htt_pdev, msdu);
-                ol_rx_fwd_to_tx(tx_vdev, msdu);
-                msdu = NULL; /* already handled this MSDU */
-            } else {
-				adf_nbuf_t copy;
-				copy = adf_nbuf_copy(msdu);
-                if (copy) {
-					ol_rx_fwd_to_tx(tx_vdev, copy);
+            if (!do_not_fwd) {
+                u_int16_t off = 0;
+                // for HL, point to payload right now
+                if (pdev->cfg.is_high_latency) {
+                    off = htt_rx_msdu_rx_desc_size_hl(pdev->htt_pdev,
+                                                      rx_desc);
+                }
+
+                /*
+                 * CR 2868053
+                 * discard EAPOL frame for intrabss forwarding
+                 */
+                if ((vdev->opmode == wlan_op_mode_ap) &&
+                    __adf_nbuf_data_is_eapol_pkt(adf_nbuf_data(msdu) + off)) {
+                    VOS_TRACE(VOS_MODULE_ID_TXRX, VOS_TRACE_LEVEL_ERROR,
+                        "\n%s:QSV2020005 EAPOL forwarding discard \n",
+                        __FUNCTION__);
+                    /* Drop the packet*/
+                    htt_rx_msdu_desc_free(pdev->htt_pdev, msdu);
+                    TXRX_STATS_MSDU_LIST_INCR(
+                        pdev, tx.dropped.host_reject, msdu);
+                    /* add NULL terminator */
+                    adf_nbuf_set_next(msdu, NULL);
+                    adf_nbuf_tx_free(msdu, 1);
+                    msdu = msdu_list;
+                    continue;
+                }
+	            if (htt_rx_msdu_discard(pdev->htt_pdev, rx_desc)) {
+	                htt_rx_msdu_desc_free(pdev->htt_pdev, msdu);
+	                ol_rx_fwd_to_tx(tx_vdev, msdu);
+	                msdu = NULL; /* already handled this MSDU */
+	            } else {
+					adf_nbuf_t copy;
+					copy = adf_nbuf_copy(msdu);
+	                if (copy) {
+						ol_rx_fwd_to_tx(tx_vdev, copy);
+		            }
                 }
             }
         }
diff -Naur qcacld-2.0-org/CORE/CLD_TXRX/TXRX/ol_rx_pn.c qcacld-2.0-new/CORE/CLD_TXRX/TXRX/ol_rx_pn.c
--- qcacld-2.0-org/CORE/CLD_TXRX/TXRX/ol_rx_pn.c	2021-06-08 13:35:52.881230782 +0800
+++ qcacld-2.0-new/CORE/CLD_TXRX/TXRX/ol_rx_pn.c	2021-06-08 13:36:15.608587634 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011, 2013-2014 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011, 2013-2014, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -91,6 +91,36 @@
     return pn_is_replay;
 }
 
+int ol_rx_pn_strict_chk(union htt_rx_pn_t *new_pn,
+						union htt_rx_pn_t *old_pn,
+						int is_unicast, int pn_len,
+						int opmode)
+{
+	int rc = 0;
+	
+	if (pn_len == 24) {
+		rc = ((new_pn->pn24 & 0xffffff) == ((old_pn->pn24 & 0xffffff) + 1));
+		return rc;
+	}
+
+	/* TKIP: 48-bit TSC, CCMP: 48-bit PN */
+	if (pn_len == 48) {
+		 rc = ((new_pn->pn48 & 0xffffffffffffULL) ==
+		 	((old_pn->pn48 & 0xffffffffffffULL) + 1));
+		  return rc;
+	}
+
+	/* WAPI: 128-bit PN */
+	if (pn_len == 128) {
+		/* TODO WAPI is not implemented, bypass this checking*/
+		rc = 1;
+	}
+
+	return rc;
+	
+}
+
+
 adf_nbuf_t
 ol_rx_pn_check_base(
     struct ol_txrx_vdev_t *vdev,
diff -Naur qcacld-2.0-org/CORE/CLD_TXRX/TXRX/ol_rx_pn.h qcacld-2.0-new/CORE/CLD_TXRX/TXRX/ol_rx_pn.h
--- qcacld-2.0-org/CORE/CLD_TXRX/TXRX/ol_rx_pn.h	2021-06-08 13:35:52.877228783 +0800
+++ qcacld-2.0-new/CORE/CLD_TXRX/TXRX/ol_rx_pn.h	2021-06-08 13:36:15.608587634 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -118,5 +118,20 @@
     unsigned tid,
     adf_nbuf_t msdu_list);
 
+/**	
+ * @brief If applicable, check the Packet Number to strict mathcing old +1 = new.	
+ *	
+ * @param new_pn - which includes new pn data	
+ * @param old_pn - which includes old pn data	
+ * @param is_unicast - unicsat frame or mcast frame for WAPI	
+ * @param pn_len - pn length	
+ * @param op_mode - op mode used for WAPI	
+ * @return list of netbufs that didn't fail the PN check	
+ */	
+int ol_rx_pn_strict_chk(union htt_rx_pn_t *new_pn,	
+	union htt_rx_pn_t *old_pn,	
+	int is_unicast, int pn_len,	
+	int opmode);
+
 
 #endif /* _OL_RX_PN_H_ */
diff -Naur qcacld-2.0-org/CORE/CLD_TXRX/TXRX/ol_txrx.c qcacld-2.0-new/CORE/CLD_TXRX/TXRX/ol_txrx.c
--- qcacld-2.0-org/CORE/CLD_TXRX/TXRX/ol_txrx.c	2021-06-08 13:35:52.877228783 +0800
+++ qcacld-2.0-new/CORE/CLD_TXRX/TXRX/ol_txrx.c	2021-06-08 13:36:15.608587634 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011-2014 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011-2014, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -485,9 +485,15 @@
     TAILQ_INIT(&pdev->rx.defrag.waitlist);
 
     /* configure where defrag timeout and duplicate detection is handled */
-    pdev->rx.flags.defrag_timeout_check =
-        pdev->rx.flags.dup_check =
-            ol_cfg_rx_host_defrag_timeout_duplicate_check(ctrl_pdev);
+	 pdev->rx.flags.defrag_timeout_check =
+	  	ol_cfg_rx_host_defrag_timeout_check(ctrl_pdev);
+	pdev->rx.flags.dup_check =
+		ol_cfg_rx_host_duplicate_check(ctrl_pdev);
+
+	if (pdev->rx.flags.defrag_timeout_check) {
+		pdev->rx.defrag.timeout_ms = DEFRAG_MIN_TIMEOUT_MS;
+	}
+
 
 #ifdef QCA_SUPPORT_SW_TXRX_ENCAP
     /* Need to revisit this part. Currently,hardcode to riva's caps */
diff -Naur qcacld-2.0-org/CORE/HDD/inc/wlan_hdd_cfg.h qcacld-2.0-new/CORE/HDD/inc/wlan_hdd_cfg.h
--- qcacld-2.0-org/CORE/HDD/inc/wlan_hdd_cfg.h	2021-06-08 13:35:52.853216782 +0800
+++ qcacld-2.0-new/CORE/HDD/inc/wlan_hdd_cfg.h	2021-06-08 13:36:15.612589634 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2012-2015 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2012-2015, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -2473,6 +2473,19 @@
 #define CFG_ENABLE_DEBUG_CONNECT_ISSUE_MAX         (0xFF)
 #define CFG_ENABLE_DEBUG_CONNECT_ISSUE_DEFAULT     (0)
 
+/*  
+    * Eapol sanity checking Enable/Disable for SAP. 
+    * 0x0 - Disable eapol sanity checking in the RX path 
+    *       before deliver to the OS in the SAP mode. 
+    * 0x1 - Enable eapol sanity checking in the RX path 
+    *       before deliver to the OS in the SAP mode. 
+    */  
+#define CFG_ENABLE_SAP_EAPOL_CHECKING             "gEnableSapEapolChecking"  
+#define CFG_ENABLE_SAP_EAPOL_CHECKING_MIN         (0)  
+#define CFG_ENABLE_SAP_EAPOL_CHECKING_MAX         (1)  
+#define CFG_ENABLE_SAP_EAPOL_CHECKING_DEFAULT     (1) 
+
+
 /* This will be used only for debugging purpose, will be removed after sometime */
 #define CFG_ENABLE_RX_THREAD                       "gEnableRxThread"
 #define CFG_ENABLE_RX_THREAD_MIN                   (0)
@@ -3415,6 +3428,7 @@
    v_U32_t                     TxPower2g;
    v_U32_t                     TxPower5g;
    v_U32_t                     gEnableDebugLog;
+   v_U32_t                     gEnableSapEapolChecking;
    v_U8_t                      enableRxThread;
    v_BOOL_t                    fDfsPhyerrFilterOffload;
    v_U8_t                      gSapPreferredChanLocation;
diff -Naur qcacld-2.0-org/CORE/HDD/src/wlan_hdd_cfg.c qcacld-2.0-new/CORE/HDD/src/wlan_hdd_cfg.c
--- qcacld-2.0-org/CORE/HDD/src/wlan_hdd_cfg.c	2021-06-08 13:35:52.845212784 +0800
+++ qcacld-2.0-new/CORE/HDD/src/wlan_hdd_cfg.c	2021-06-08 13:36:15.616591633 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2012-2015 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2012-2015, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -3397,6 +3397,13 @@
                  CFG_ENABLE_DEBUG_CONNECT_ISSUE_MIN ,
                  CFG_ENABLE_DEBUG_CONNECT_ISSUE_MAX),
 
+   REG_VARIABLE( CFG_ENABLE_SAP_EAPOL_CHECKING, WLAN_PARAM_Integer, 
+				 hdd_config_t, gEnableSapEapolChecking, 
+				 VAR_FLAGS_OPTIONAL | VAR_FLAGS_RANGE_CHECK_ASSUME_DEFAULT, 
+				 CFG_ENABLE_SAP_EAPOL_CHECKING_DEFAULT, 
+				 CFG_ENABLE_SAP_EAPOL_CHECKING_MIN , 
+				 CFG_ENABLE_SAP_EAPOL_CHECKING_MAX), 
+
    REG_VARIABLE( CFG_ENABLE_RX_THREAD, WLAN_PARAM_Integer,
                  hdd_config_t, enableRxThread,
                  VAR_FLAGS_OPTIONAL | VAR_FLAGS_RANGE_CHECK_ASSUME_DEFAULT,
diff -Naur qcacld-2.0-org/CORE/HDD/src/wlan_hdd_softap_tx_rx.c qcacld-2.0-new/CORE/HDD/src/wlan_hdd_softap_tx_rx.c
--- qcacld-2.0-org/CORE/HDD/src/wlan_hdd_softap_tx_rx.c	2021-06-08 13:35:52.837208785 +0800
+++ qcacld-2.0-new/CORE/HDD/src/wlan_hdd_softap_tx_rx.c	2021-06-08 13:36:15.616591633 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2012-2014 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2012-2014, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -1265,8 +1265,34 @@
    }
 #endif /* QCA_PKT_PROTO_TRACE */
 
-   VOS_TRACE( VOS_MODULE_ID_HDD_SAP_DATA, VOS_TRACE_LEVEL_INFO_LOW,
-              "%s: send one packet to kernel", __func__);
+      if (pHddCtx->cfg_ini->gEnableSapEapolChecking) {
+          if (adf_nbuf_is_eapol_pkt(skb) == A_STATUS_OK) {
+              /* CR 2868053 */
+              VOS_TRACE(VOS_MODULE_ID_HDD_DATA, VOS_TRACE_LEVEL_INFO,
+                  "%s: QSV2020005, dev, mode=%d, session=%u, %s, addr (%pM)",
+                  __FUNCTION__,
+                  pAdapter->device_mode,
+                  pAdapter->sessionId,
+                  pAdapter->dev->name,
+                  pAdapter->dev->dev_addr);
+              VOS_TRACE(VOS_MODULE_ID_HDD_DATA, VOS_TRACE_LEVEL_INFO,
+                  "%s:QSV2020005 pkt addr (%pM)",
+                  __FUNCTION__,
+                  skb->data);
+              if (adf_os_mem_cmp(pAdapter->dev->dev_addr,
+                skb->data, VOS_MAC_ADDR_SIZE)) {
+                  /* CR 2868053, discard this EAPOL */
+                  VOS_TRACE(VOS_MODULE_ID_HDD_DATA, VOS_TRACE_LEVEL_ERROR,
+                      "%s:QSV2020005 discard invalid EAPOL frame, dev=%pM, "
+                      "pkt_da=%pM",
+                      __FUNCTION__,
+                      pAdapter->dev->dev_addr,
+                      skb->data);
+
+                  return VOS_STATUS_E_FAILURE;
+              }
+          }
+      }
 
    skb->protocol = eth_type_trans(skb, skb->dev);
 #ifdef WLAN_FEATURE_HOLD_RX_WAKELOCK
diff -Naur qcacld-2.0-org/CORE/SERVICES/COMMON/adf/adf_nbuf.c qcacld-2.0-new/CORE/SERVICES/COMMON/adf/adf_nbuf.c
--- qcacld-2.0-org/CORE/SERVICES/COMMON/adf/adf_nbuf.c	2021-06-08 13:35:52.945262779 +0800
+++ qcacld-2.0-new/CORE/SERVICES/COMMON/adf/adf_nbuf.c	2021-06-08 13:36:15.620593633 +0800
@@ -423,6 +423,32 @@
     }
 }
 
+/**
+ * __adf_nbuf_data_is_eapol_pkt() - check if it is EAPOL packet.
+ * @data: Pointer to EAPOL packet data buffer
+ *
+ * This func. checks whether it is a EAPOL packet or not.
+ *
+ * Return: TRUE if it is a EAPOL packet
+ *         FALSE if not
+ */
+bool __adf_nbuf_data_is_eapol_pkt(uint8_t *data)
+{
+    a_uint16_t    ether_type;
+
+    ether_type = (a_uint16_t)(*(a_uint16_t *)(data +
+			ADF_NBUF_TRAC_ETH_TYPE_OFFSET));
+    if (ADF_NBUF_TRAC_EAPOL_ETH_TYPE == adf_os_cpu_to_be16(ether_type))
+    {
+        return true;
+    }
+    else
+    {
+        return false;
+    }
+}
+
+
 #ifdef QCA_PKT_PROTO_TRACE
 void
 __adf_nbuf_trace_update(struct sk_buff *buf, char *event_string)
diff -Naur qcacld-2.0-org/CORE/SERVICES/COMMON/adf/adf_nbuf.h qcacld-2.0-new/CORE/SERVICES/COMMON/adf/adf_nbuf.h
--- qcacld-2.0-org/CORE/SERVICES/COMMON/adf/adf_nbuf.h	2021-06-08 13:35:52.945262779 +0800
+++ qcacld-2.0-new/CORE/SERVICES/COMMON/adf/adf_nbuf.h	2021-06-08 13:36:15.620593633 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2013-2014 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2013-2014, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -1165,4 +1165,20 @@
 {
     return (__adf_nbuf_is_eapol_pkt(buf));
 }
+
+/**
+ * adf_nbuf_data_is_eapol_pkt() - check if it is EAPOL packet.
+ * @data: Pointer to EAPOL packet data buffer
+ *
+ * This func. checks whether it is a EAPOL packet or not.
+ *
+ * Return: TRUE if it is a EAPOL packet
+ *         FALSE if not
+ */
+static inline
+bool adf_nbuf_data_is_eapol_pkt(uint8_t *data)
+{
+	return __adf_nbuf_data_is_eapol_pkt(data);
+}
+
 #endif
diff -Naur qcacld-2.0-org/CORE/SERVICES/COMMON/adf/linux/adf_nbuf_pvt.h qcacld-2.0-new/CORE/SERVICES/COMMON/adf/linux/adf_nbuf_pvt.h
--- qcacld-2.0-org/CORE/SERVICES/COMMON/adf/linux/adf_nbuf_pvt.h	2021-06-08 13:35:52.941260778 +0800
+++ qcacld-2.0-new/CORE/SERVICES/COMMON/adf/linux/adf_nbuf_pvt.h	2021-06-08 13:36:15.620593633 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2013-2014 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2013-2014, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -266,6 +266,8 @@
 void            __adf_nbuf_reg_trace_cb(adf_nbuf_trace_update_t cb_func_ptr);
 a_status_t      __adf_nbuf_is_dhcp_pkt(struct sk_buff *skb);
 a_status_t      __adf_nbuf_is_eapol_pkt(struct sk_buff *skb);
+bool            __adf_nbuf_data_is_eapol_pkt(uint8_t *data);
+
 
 #ifdef QCA_PKT_PROTO_TRACE
 void
diff -Naur qcacld-2.0-org/CORE/SERVICES/COMMON/ol_cfg.h qcacld-2.0-new/CORE/SERVICES/COMMON/ol_cfg.h
--- qcacld-2.0-org/CORE/SERVICES/COMMON/ol_cfg.h	2021-06-08 13:35:52.937258779 +0800
+++ qcacld-2.0-new/CORE/SERVICES/COMMON/ol_cfg.h	2021-06-08 13:36:15.620593633 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011-2014 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011-2014, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -49,6 +49,12 @@
     wlan_frm_fmt_802_3,
 };
 
+#if CFG_TGT_DEFAULT_RX_SKIP_DEFRAG_TIMEOUT_DUP_DETECTION_CHECK 
+#define DEFRAG_MIN_TIMEOUT_MS 100
+#else
+#define DEFRAG_MIN_TIMEOUT_MS 0
+#endif
+
 #ifdef IPA_UC_OFFLOAD
 struct wlan_ipa_uc_rsc_t {
    u8  uc_offload_enabled;
@@ -63,6 +69,7 @@
 struct txrx_pdev_cfg_t {
 	u8 is_high_latency;
 	u8 defrag_timeout_check;
+	u8 dup_check;
 	u8 rx_pn_check;
 	u8 pn_rx_fwd_check;
 	u8 host_addba;
@@ -318,7 +325,7 @@
 int ol_cfg_tx_download_size(ol_pdev_handle pdev);
 
 /**
- * brief Specify where defrag timeout and duplicate detection is handled
+ * brief Specify where defrag timeout is handled
  * @details
  *   non-aggregate duplicate detection and timing out stale fragments
  *   requires additional target memory. To reach max client
@@ -333,7 +340,26 @@
  *  1 -> host is responsible non-aggregate duplicate detection and
  *          timing out stale fragments.
  */
-int ol_cfg_rx_host_defrag_timeout_duplicate_check(ol_pdev_handle pdev);
+int ol_cfg_rx_host_defrag_timeout_check(ol_pdev_handle pdev);
+
+/**  
+ * brief Specify where duplicate detection is handled  
+ * @details  
+ *   non-aggregate duplicate detection and timing out stale fragments  
+ *   requires additional target memory. To reach max client  
+ *   configurations (128+), non-aggregate duplicate detection and the  
+ *   logic to time out stale fragments is moved to the host.  
+ *  
+ * @param pdev - handle to the physical device  
+ * @return  
+ *  0 -> target is responsible non-aggregate duplicate detection and  
+ *          timing out stale fragments.  
+ *  
+ *  1 -> host is responsible non-aggregate duplicate detection and  
+ *          timing out stale fragments.  
+ */  
+ int ol_cfg_rx_host_duplicate_check(ol_pdev_handle pdev); 
+
 
 /**
  * brief Query for the period in ms used for throttling for
diff -Naur qcacld-2.0-org/CORE/SERVICES/COMMON/wlan_tgt_def_config.h qcacld-2.0-new/CORE/SERVICES/COMMON/wlan_tgt_def_config.h
--- qcacld-2.0-org/CORE/SERVICES/COMMON/wlan_tgt_def_config.h	2021-06-08 13:35:52.945262779 +0800
+++ qcacld-2.0-new/CORE/SERVICES/COMMON/wlan_tgt_def_config.h	2021-06-08 13:36:15.620593633 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2011, 2014-2015 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2011, 2014-2015, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -167,7 +167,7 @@
 #define CFG_TGT_DEFAULT_TX_DBG_LOG_SIZE 1024 /* bytes */
 
 /* target based fragment timeout and MPDU duplicate detection */
-#define CFG_TGT_DEFAULT_RX_SKIP_DEFRAG_TIMEOUT_DUP_DETECTION_CHECK 0
+#define CFG_TGT_DEFAULT_RX_SKIP_DEFRAG_TIMEOUT_DUP_DETECTION_CHECK 1
 
 /*  Default VoW configuration
  */
diff -Naur qcacld-2.0-org/CORE/SERVICES/COMMON/wlan_tgt_def_config_hl.h qcacld-2.0-new/CORE/SERVICES/COMMON/wlan_tgt_def_config_hl.h
--- qcacld-2.0-org/CORE/SERVICES/COMMON/wlan_tgt_def_config_hl.h	2021-06-08 13:35:52.949264779 +0800
+++ qcacld-2.0-new/CORE/SERVICES/COMMON/wlan_tgt_def_config_hl.h	2021-06-08 13:36:15.620593633 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2013-2015 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2013-2015, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -199,7 +199,7 @@
 #define CFG_TGT_DEFAULT_TX_DBG_LOG_SIZE 1024 /* bytes */
 
 /* target based fragment timeout and MPDU duplicate detection */
-#define CFG_TGT_DEFAULT_RX_SKIP_DEFRAG_TIMEOUT_DUP_DETECTION_CHECK 0
+#define CFG_TGT_DEFAULT_RX_SKIP_DEFRAG_TIMEOUT_DUP_DETECTION_CHECK 1
 /*  Default VoW configuration
  */
 #define CFG_TGT_DEFAULT_VOW_CONFIG   0
diff -Naur qcacld-2.0-org/CORE/SERVICES/WMA/wma.c qcacld-2.0-new/CORE/SERVICES/WMA/wma.c
--- qcacld-2.0-org/CORE/SERVICES/WMA/wma.c	2021-06-08 13:35:52.961270777 +0800
+++ qcacld-2.0-new/CORE/SERVICES/WMA/wma.c	2021-06-08 13:36:15.632599632 +0800
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 2013-2015 The Linux Foundation. All rights reserved.
+ * Copyright (c) 2013-2015, 2021 The Linux Foundation. All rights reserved.
  *
  * Previously licensed under the ISC license by Qualcomm Atheros, Inc.
  *
@@ -108,6 +108,8 @@
 
 #include "wma_ocb.h"
 
+#include "ol_rx_reorder.h"
+
 /* ################### defines ################### */
 /*
  * TODO: Following constant should be shared by firwmare in
@@ -14257,6 +14259,12 @@
 			goto out;
 		}
 	}
+		
+        WMA_LOGD("%s: QSV2020002, vid(%u), rx cleanup for peer(%pM) after key install",	
+            __func__,	
+            txrx_vdev->vdev_id,	
+            peer->mac_addr.raw);	
+        ol_rx_reorder_peer_cleanup(txrx_vdev, peer);
 
         /* In IBSS mode, set the BSS KEY for this peer
          ** BSS key is supposed to be cache into wma_handle
